import java.util.*;


interface Visitor {
    public void visit(Colddrink cld_drnk);
}
interface Colddrink {
    public String Order();
}
class Pepsi implements Colddrink {
    final String name = "Pepsi";
    public String Order() {
        return name;
    }
}
class CocaCola implements Colddrink {
    final String name = "Coke";
    public String Order() {
        return name;
    }
}

class Pickup implements Visitor {
    private String name;
    private final String method = "Pick and Go";
    public void visit(Colddrink cld_drnk) {
        name = cld_drnk.Order();
    }
    
    public String toString() {
         return name + " " + method;
    }
}
class Drinkthere implements Visitor {
    private String name;
    private final String method = "Take the drink over there";
    
    public void visit(Colddrink cld_drnk) {
        name = cld_drnk.Order();
    }
    
    public String toString() {
        return name + " " + method;
    }
}
class GetByDelivery implements Visitor {
    private String name;
    private final String method = "Get it by delivery";
    
    public void visit(Colddrink cld_drnk) {
        name = cld_drnk.Order();
    }
    
    public String toString() {
         return name + " " + method;
    }
}
class Drink {
    public Colddrink getDrink() {
        switch ((int)(Math.random()*3)){
            case 0: return new Pepsi(); 
            case 1: return new CocaCola(); 
            default: return null;
        }
    }
    public Visitor howto() {
        switch ((int)(Math.random()*3)){
            case 0: return new Pickup(); 
            case 1: return new Drinkthere(); 
            case 2: return new GetByDelivery(); 
            default: return null;
        }
    }    
}
class TestVisitors {
    
    public static void main(String[] args) {
        List colddrinkList = new ArrayList();
            colddrinkList.add(new Pepsi());
            colddrinkList.add(new CocaCola());

        Iterator it = colddrinkList.iterator();
        System.out.println("How many Cold drink Shop are there in this area?");
        while (it.hasNext()) {
           System.out.println(((Colddrink)it.next()).Order());
        }
        Drink drink = new Drink();
        Colddrink cld_drnk = drink.getDrink();
        Visitor vstr = drink.howto();
        vstr.visit(cld_drnk);
        System.out.println("\n\nChoose the shop to take the drink?");
        System.out.println(vstr);
    }
}
